import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:flutter/material.dart';

class ForgotPasswordScreen extends StatefulWidget {
  @override
  _ForgotPasswordScreenState createState() => _ForgotPasswordScreenState();
}

class _ForgotPasswordScreenState extends State<ForgotPasswordScreen> {
  String _email;
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Reset password link"),
      ),
      body: Center(
        child: Padding(
          padding: const EdgeInsets.all(8.0),
          child: Column(
              crossAxisAlignment: CrossAxisAlignment.stretch,
              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
              children: [
                TextField(
                  decoration: InputDecoration(
                      labelText: "Email",
                      hintText: "exampleresetlink@email.com",
                      icon: Icon(Icons.email)),
                  onChanged: (text) {
                    setState(() {
                      _email = text;
                    });
                  },
                ),
                ElevatedButton(
                  child: Text("Request reset link"),
                  onPressed: _email == null
                      ? null
                      : () {
                          FirebaseAuth.instance
                              .sendPasswordResetEmail(email: _email)
                              .then((value) {
                            ScaffoldMessenger.of(context).showSnackBar(
                              SnackBar(
                                content: Text("Please check your Emails"),
                              ),
                            );

                            FirebaseAnalytics().logEvent(
                                name: "forgot_password",
                                parameters: {
                                  "date": DateTime.now().millisecondsSinceEpoch,
                                  "email": _email
                                });
                          }).catchError((err) {
                            ScaffoldMessenger.of(context).showSnackBar(
                              SnackBar(
                                content: Text("$err \n\n please try again"),
                              ),
                            );
                          });
                        },
                ),
              ]),
        ),
      ),
    );
  }
}
